
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;												;
;		Generating Video Signals 1				;
;		By Brad Slattery 2009					;
;												;
;		For more info:							;
;		web - www.bradsprojects.com				;
;		email - brad@bradsprojects.com			;
;												;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	LIST p=16f648a 					; tell assembler what chip we are using
	include "P16f648a.inc"			; include the defaults for the chip
	__config 0x3f18					; sets the configuration settings (oscillator type etc.)

	cblock h'20' 					;	this is where we start defining variables
	
	endc							;	end of variable declarations

	org h'0000'						; 	sets our start address


	movlw h'07'
	movwf CMCON 					; we want all ports to act purely as digital ports

	bsf STATUS, RP0 				; select bank 1
	movlw b'00000000' 				; 
	movwf TRISB						;
	movlw b'00100000' 				; set PORTA all outputs except for bit 5
	movwf TRISA 					;
	bcf STATUS, RP0 				; select bank 0


setup								;	have this here incase anything requires seting up, before we run the main code.




									;	the begin loop here goes for exactly 64us (one scanline)

begin

	clrf PORTB						;	clear PORTB so that we send a logic 0 to the tv for our 4us sync pulse	(this is also the first 1us)				
	nop								;	delay 1us
	nop								;	delay 1us

	movlw b'00000001'				;	prepare for the 8us wait pulse (this also takes 1us and is the last of the 4us delays)
	movwf PORTB						;	we will now hold this data on PORTB for 8us (this is the first 1us)
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us

	movlw b'00000010'				;	now it's time to display SOMETHING on the screen, in this case
	movwf PORTB						;	it is a dark grey line
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us

	movlw b'00000011'				;	now lets make things a bit brighter!
	movwf PORTB						;	this draws a white line
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us

	movlw b'00000010'				;	and back to our dark grey....
	movwf PORTB						;	
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us

	movlw b'00000001'				;	and finally, lets make the right hand side, black
	movwf PORTB						;
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us
	nop								;	delay 1us

	goto begin						;	this takes 2us to go back to the beginning





	end